| http://www.sim.no/ http://www.coin3d.org/

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
SoMFEngine Class Reference
Field Classes

The SoMFEngine class is a container for engines.This field container stores an array of pointers to engines. It takes care of the necessary functionality for handling copy, import and export operations. More...

`#include <Inventor/fields/SoMFEngine.h>`

Inheritance diagram for SoMFEngine:

## Public Member Functions

virtual SoType | getTypeId (void) const
virtual void | copyFrom (const SoField &field)
const SoMFEngine & | operator= (const SoMFEngine &field)
virtual SbBool | isSame (const SoField &field) const
SoEngine * | operator[] (const int idx) const
const SoEngine ** | getValues (const int start) const
int | find (SoEngine *value, SbBool addifnotfound=FALSE)
void | setValues (const int start, const int num, const SoEngine **newvals)
void | set1Value (const int idx, SoEngine *value)
void | setValue (SoEngine *value)
SoEngine * | operator= (SoEngine *val)
SbBool | operator== (const SoMFEngine &field) const
SbBool | operator!= (const SoMFEngine &field) const
SoEngine ** | startEditing (void)
void | finishEditing (void)
virtual void | fixCopy (SbBool copyconnections)
virtual SbBool | referencesCopy (void) const
virtual void | deleteValues (int start, int num=-1)
virtual void | insertSpace (int start, int num)
Public Member Functions inherited from SoMField
virtual | ~SoMField ()
int | getNum (void) const
void | setNum (const int num)
SbBool | set1 (const int index, const char *const valuestring)
void | get1 (const int index, SbString &valuestring)
virtual void | enableDeleteValues (void)
virtual SbBool | isDeleteValuesEnabled (void) const
Public Member Functions inherited from SoField
virtual | ~SoField ()
void | setIgnored (SbBool ignore)
SbBool | isIgnored (void) const
void | setDefault (SbBool defaultVal)
SbBool | isDefault (void) const
SbBool | isOfType (const SoType type) const
void | enableConnection (SbBool flag)
SbBool | isConnectionEnabled (void) const
SbBool | connectFrom (SoEngineOutput *master, SbBool notnotify=FALSE, SbBool append=FALSE)
SbBool | appendConnection (SoEngineOutput *master, SbBool notnotify=FALSE)
void | disconnect (SoEngineOutput *engineoutput)
SbBool | isConnectedFromEngine (void) const
SbBool | getConnectedEngine (SoEngineOutput *&master) const
SbBool | connectFrom (SoField *master, SbBool notnotify=FALSE, SbBool append=FALSE)
SbBool | appendConnection (SoField *master, SbBool notnotify=FALSE)
void | disconnect (SoField *field)
SbBool | isConnectedFromField (void) const
SbBool | getConnectedField (SoField *&master) const
int | getNumConnections (void) const
int | getForwardConnections (SoFieldList &slavelist) const
int | getConnections (SoFieldList &masterlist) const
void | disconnect (void)
SbBool | isConnected (void) const
void | setContainer (SoFieldContainer *cont)
SoFieldContainer * | getContainer (void) const
SbBool | set (const char *valuestring)
void | get (SbString &valuestring)
SbBool | shouldWrite (void) const
virtual void | touch (void)
virtual void | startNotify (void)
virtual void | notify (SoNotList *nlist)
SbBool | enableNotify (SbBool on)
SbBool | isNotifyEnabled (void) const
void | addAuditor (void *f, SoNotRec::Type type)
void | removeAuditor (void *f, SoNotRec::Type type)
int | operator== (const SoField &f) const
int | operator!= (const SoField &f) const
virtual void | connectionStatusChanged (int numconnections)
SbBool | isReadOnly (void) const
void | copyConnection (const SoField *fromfield)
virtual SbBool | read (SoInput *input, const SbName &name)
virtual void | write (SoOutput *out, const SbName &name) const
void | setFieldType (int type)
int | getFieldType (void) const
SbBool | getDirty (void) const
void | setDirty (SbBool dirty)
void | evaluate (void) const

## Static Public Member Functions

static void * | createInstance (void)
static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoMField
static SoType | getClassTypeId (void)
static void | atexit_cleanup (void)
static void | initClass (void)
Static Public Member Functions inherited from SoField
static void | initClass (void)
static void | initClasses (void)
static void | cleanupClass (void)
static SoType | getClassTypeId (void)

## Protected Member Functions

virtual void | deleteAllValues (void)
virtual void | copyValue (int to, int from)
virtual int | fieldSizeof (void) const
virtual void * | valuesPtr (void)
virtual void | setValuesPtr (void *ptr)
virtual void | allocValues (int num)
Protected Member Functions inherited from SoMField
| SoMField (void)
virtual void | makeRoom (int newnum)
Protected Member Functions inherited from SoField
| SoField (void)
void | valueChanged (SbBool resetdefault=TRUE)
virtual void | evaluateConnection (void) const
virtual SbBool | readConnection (SoInput *in)
virtual void | writeConnection (SoOutput *out) const
SbBool | isDestructing (void) const

## Protected Attributes

SoEngine ** | values
Protected Attributes inherited from SoMField
int | num
int | maxNum
SbBool | userDataIsUsed

## Additional Inherited Members

Public Types inherited from SoField
enum | FieldType { NORMAL_FIELD = 0, EVENTIN_FIELD, EVENTOUT_FIELD, EXPOSED_FIELD }

## Detailed Description

The SoMFEngine class is a container for engines.

This field container stores an array of pointers to engines. It takes care of the necessary functionality for handling copy, import and export operations.

Note that engine pointers stored in field instances of this type may be `NULL` pointers.

See Also
  SoEngine, SoSFEngine

## Member Function Documentation

SoType SoMFEngine::getTypeId | ( | void | ) |  | const

virtual

Returns the type identification instance which uniquely identifies the Coin field class the object belongs to.

See Also
  getClassTypeId(), SoType

Implements SoField.

void SoMFEngine::copyFrom | ( | const SoField & | f) |  |

virtual

Copy value(s) from f into this field. f must be of the same type as this field.

Implements SoField.

SbBool SoMFEngine::isSame | ( | const SoField & | f) |  | const

virtual

Check for equal type and value(s).

Implements SoField.

const SoEngine* * SoMFEngine::getValues | ( | const int | start) |  | const

inline

\ Returns a pointer to the values array. \

void SoMFEngine::fixCopy | ( | SbBool | copyconnections) |  |

virtual

This method is internally called after SoField::copyFrom() during scene graph copies, and should do the operations necessary for fixing up the field instance after it has gotten a new value.

The default method in the SoField superclass does nothing.

The application programmer should normally not need to consider this method, unless he constructs a complex field type which contains new references to container instances (i.e. nodes or engines). Overriding this method is then necessary to update the reference pointers, as they could have been duplicated during the copy operation.

Reimplemented from SoField.

SbBool SoMFEngine::referencesCopy | ( | void | ) |  | const

virtual

Returns `TRUE` if this field has references to any containers in the scene graph which are also duplicated during the copy operation.

Note that this method only is valid to call during copy operations.

See also the note about the relevance of the fixCopy() method for application programmers, as it is applicable on this method aswell.

Reimplemented from SoField.

virtual void SoMFEngine::deleteValues | ( | int | start,
|  | int | numarg = `-1`
| ) |  |

virtual

Remove value elements from index start up to and including index start + num - 1.

Elements with indices larger than the last deleted element will be moved downwards in the value array.

If num equals -1, delete from index start and to the end of the array.

Reimplemented from SoMField.

virtual void SoMFEngine::insertSpace | ( | int | start,
|  | int | numarg
| ) |  |

virtual

Insert num "slots" for new value elements from start. The elements already present from start will be moved "upward" in the extended array.

Reimplemented from SoMField.

The documentation for this class was generated from the following files:

- SoMFEngine.h
- SoMFEngine.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.